Index: pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 4889)
+++ pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 4890)
@@ -498,5 +498,5 @@
         bytes_read = read_op->size;
 
-	if ((read_op->op == PJ_IOQUEUE_OP_RECV_FROM)) {
+	if (read_op->op == PJ_IOQUEUE_OP_RECV_FROM) {
 	    read_op->op = PJ_IOQUEUE_OP_NONE;
 	    rc = pj_sock_recvfrom(h->fd, read_op->buf, &bytes_read, 
@@ -504,5 +504,5 @@
 				  read_op->rmt_addr, 
                                   read_op->rmt_addrlen);
-	} else if ((read_op->op == PJ_IOQUEUE_OP_RECV)) {
+	} else if (read_op->op == PJ_IOQUEUE_OP_RECV) {
 	    read_op->op = PJ_IOQUEUE_OP_NONE;
 	    rc = pj_sock_recv(h->fd, read_op->buf, &bytes_read, 
Index: pjproject/trunk/pjlib/src/pj/os_timestamp_posix.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_timestamp_posix.c	(revision 4889)
+++ pjproject/trunk/pjlib/src/pj/os_timestamp_posix.c	(revision 4890)
@@ -126,5 +126,7 @@
 #include <errno.h>
 
-#define NSEC_PER_SEC	1000000000
+#ifndef NSEC_PER_SEC
+#	define NSEC_PER_SEC	1000000000
+#endif
 
 PJ_DEF(pj_status_t) pj_get_timestamp(pj_timestamp *ts)
Index: pjproject/trunk/pjlib/src/pj/pool.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/pool.c	(revision 4889)
+++ pjproject/trunk/pjlib/src/pj/pool.c	(revision 4890)
@@ -144,5 +144,5 @@
 #if PJ_DEBUG
     if (p == NULL) {
-	p = p;
+	PJ_UNUSED_ARG(p);
     }
 #endif
Index: pjproject/trunk/pjlib/src/pjlib-test/exception.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/exception.c	(revision 4889)
+++ pjproject/trunk/pjlib/src/pjlib-test/exception.c	(revision 4890)
@@ -121,5 +121,5 @@
      */
     PJ_TRY {
-        rc = rc;
+        PJ_UNUSED_ARG(rc);
     }
     PJ_CATCH_ANY {
Index: pjproject/trunk/pjmedia/src/pjmedia/endpoint.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 4889)
+++ pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 4890)
@@ -35,6 +35,4 @@
 #define THIS_FILE   "endpoint.c"
 
-static const pj_str_t STR_AUDIO = { "audio", 5};
-static const pj_str_t STR_VIDEO = { "video", 5};
 static const pj_str_t STR_IN = { "IN", 2 };
 static const pj_str_t STR_IP4 = { "IP4", 3};
Index: pjproject/trunk/pjmedia/src/pjmedia/session.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/session.c	(revision 4889)
+++ pjproject/trunk/pjmedia/src/pjmedia/session.c	(revision 4890)
@@ -49,22 +49,4 @@
 #endif
 
-
-static const pj_str_t ID_AUDIO = { "audio", 5};
-static const pj_str_t ID_VIDEO = { "video", 5};
-static const pj_str_t ID_APPLICATION = { "application", 11};
-static const pj_str_t ID_IN = { "IN", 2 };
-static const pj_str_t ID_IP4 = { "IP4", 3};
-static const pj_str_t ID_IP6 = { "IP6", 3};
-static const pj_str_t ID_RTP_AVP = { "RTP/AVP", 7 };
-static const pj_str_t ID_RTP_SAVP = { "RTP/SAVP", 8 };
-//static const pj_str_t ID_SDP_NAME = { "pjmedia", 7 };
-static const pj_str_t ID_RTPMAP = { "rtpmap", 6 };
-static const pj_str_t ID_TELEPHONE_EVENT = { "telephone-event", 15 };
-
-static const pj_str_t STR_INACTIVE = { "inactive", 8 };
-static const pj_str_t STR_SENDRECV = { "sendrecv", 8 };
-static const pj_str_t STR_SENDONLY = { "sendonly", 8 };
-static const pj_str_t STR_RECVONLY = { "recvonly", 8 };
-
 /*
  * Initialize session info from SDP session descriptors.
Index: pjproject/trunk/pjmedia/src/pjmedia/stream_info.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/stream_info.c	(revision 4889)
+++ pjproject/trunk/pjmedia/src/pjmedia/stream_info.c	(revision 4890)
@@ -33,10 +33,4 @@
 static const pj_str_t ID_TELEPHONE_EVENT = { "telephone-event", 15 };
 
-static const pj_str_t STR_INACTIVE = { "inactive", 8 };
-static const pj_str_t STR_SENDRECV = { "sendrecv", 8 };
-static const pj_str_t STR_SENDONLY = { "sendonly", 8 };
-static const pj_str_t STR_RECVONLY = { "recvonly", 8 };
-
-
 /*
  * Internal function for collecting codec info and param from the SDP media.
@@ -326,4 +320,8 @@
 					   unsigned stream_idx)
 {
+    const pj_str_t STR_INACTIVE = { "inactive", 8 };
+    const pj_str_t STR_SENDONLY = { "sendonly", 8 };
+    const pj_str_t STR_RECVONLY = { "recvonly", 8 };
+
     pjmedia_codec_mgr *mgr;
     const pjmedia_sdp_attr *attr;
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_stream_info.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_stream_info.c	(revision 4889)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_stream_info.c	(revision 4890)
@@ -34,10 +34,4 @@
 static const pj_str_t ID_RTPMAP = { "rtpmap", 6 };
 
-static const pj_str_t STR_INACTIVE = { "inactive", 8 };
-static const pj_str_t STR_SENDRECV = { "sendrecv", 8 };
-static const pj_str_t STR_SENDONLY = { "sendonly", 8 };
-static const pj_str_t STR_RECVONLY = { "recvonly", 8 };
-
-
 /*
  * Internal function for collecting codec info and param from the SDP media.
@@ -191,4 +185,8 @@
 					   unsigned stream_idx)
 {
+    const pj_str_t STR_INACTIVE = { "inactive", 8 };
+    const pj_str_t STR_SENDONLY = { "sendonly", 8 };
+    const pj_str_t STR_RECVONLY = { "recvonly", 8 };
+
     const pjmedia_sdp_attr *attr;
     const pjmedia_sdp_media *local_m;
Index: pjproject/trunk/pjnath/src/pjnath/stun_auth.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_auth.c	(revision 4889)
+++ pjproject/trunk/pjnath/src/pjnath/stun_auth.c	(revision 4890)
@@ -150,8 +150,8 @@
 
 
-PJ_INLINE(pj_uint16_t) GET_VAL16(const pj_uint8_t *pdu, unsigned pos)
+/*unused PJ_INLINE(pj_uint16_t) GET_VAL16(const pj_uint8_t *pdu, unsigned pos)
 {
     return (pj_uint16_t) ((pdu[pos] << 8) + pdu[pos+1]);
-}
+}*/
 
 
Index: pjproject/trunk/pjnath/src/pjnath/stun_msg.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 4889)
+++ pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 4890)
@@ -753,8 +753,8 @@
 }
 
-PJ_INLINE(pj_uint16_t) GETVAL16N(const pj_uint8_t *buf, unsigned pos)
+/*unused PJ_INLINE(pj_uint16_t) GETVAL16N(const pj_uint8_t *buf, unsigned pos)
 {
     return pj_htons(GETVAL16H(buf,pos));
-}
+}*/
 
 static void PUTVAL16H(pj_uint8_t *buf, unsigned pos, pj_uint16_t hval)
@@ -772,8 +772,8 @@
 }
 
-PJ_INLINE(pj_uint32_t) GETVAL32N(const pj_uint8_t *buf, unsigned pos)
+/*unused PJ_INLINE(pj_uint32_t) GETVAL32N(const pj_uint8_t *buf, unsigned pos)
 {
     return pj_htonl(GETVAL32H(buf,pos));
-}
+}*/
 
 static void PUTVAL32H(pj_uint8_t *buf, unsigned pos, pj_uint32_t hval)
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 4889)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 4890)
@@ -80,5 +80,4 @@
 static const pj_str_t STR_MESSAGE = { "message", 7 };
 static const pj_str_t STR_SIPFRAG = { "sipfrag", 7 };
-static const pj_str_t STR_SIPFRAG_VERSION = {";version=2.0", 12 };
 
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 4889)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 4890)
@@ -69,6 +69,4 @@
 static const pj_str_t STR_MIME_APP	   = { "application", 11 };
 static const pj_str_t STR_MIME_ISCOMPOSING = { "im-iscomposing+xml", 18 };
-static const pj_str_t STR_MIME_TEXT	   = { "text", 4 };
-static const pj_str_t STR_MIME_PLAIN	   = { "plain", 5 };
 
 
@@ -77,4 +75,6 @@
 static pj_bool_t acceptable_message(const pjsip_media_type *mime)
 {
+    const pj_str_t STR_MIME_TEXT	   = { "text", 4 };
+    const pj_str_t STR_MIME_PLAIN	   = { "plain", 5 };
     return (pj_stricmp(&mime->type, &STR_MIME_TEXT)==0 &&
 	    pj_stricmp(&mime->subtype, &STR_MIME_PLAIN)==0)